package Modelo;

//import java.io.File;
import java.util.ArrayList; 
import java.util.Observable;
//import javax.swing.tree.DefaultMutableTreeNode;
//import javax.xml.parsers.DocumentBuilder;
//import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
//import org.w3c.dom.DOMImplementation;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Text;

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.9A3170D6-46A9-826A-FD41-62CCF154D9E0]
// </editor-fold> 
public class DocumentoReq extends Observable{


    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.AD2CFA70-6D3B-6112-498A-DFC58CBBEA9E]
    // </editor-fold> 
    private ArrayList<Elemento_trazable> mCaso_de_uso=new ArrayList();

    private ArrayList<Elemento_trazable> mRequisito_funcional=new ArrayList();

    private ArrayList<Elemento_trazable> mRequisito_Informacion=new ArrayList();

    private ArrayList<Elemento_trazable> mRequisito_noFuncional=new ArrayList();

    private ArrayList<Elemento_trazable> mObjetivo=new ArrayList();

    private ArrayList<Elemento_no_trazable> mParticipante=new ArrayList();

    private ArrayList<Elemento_no_trazable> mOrganizacion= new ArrayList();

    private ArrayList<Elemento_no_trazable> mReunion=new ArrayList();
    // <editor-fold defaultstate="collapsed" desc=" UML Marker ">
    // #[regen=yes,id=DCE.9E78B0E9-53A7-5C64-1340-81339CAE97DD]
    // </editor-fold> 
    public DocumentoReq () {
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.146E6F51-B37B-C9F7-80C6-5D93847A1307]
    // </editor-fold> 
    public Caso_de_uso crearCU (String nombreCU, String comentario,ArrayList<Participante> autor,ArrayList<Participante> fuente,String importancia,String urgencia, String estadodeDesarrollo,String estabilidad,boolean esAbstracto,String eventoActivacion, int frecuencia, String unidadFrecuencia, String precondicion, String postcondicion) {
                //// Creo la instancia
        Caso_de_uso auxCU=new Caso_de_uso();
        //// Asigno los valores a los atributos
        auxCU.setNombre(nombreCU);
        auxCU.setComentario(comentario);
        auxCU.setMAutor(autor);
        auxCU.setMFuente(fuente);
//        auxCU.setParticipante(participante);
//        auxCU.setFuente(fuente);
        auxCU.setImportancia(importancia);
        auxCU.setUrgencia(urgencia);
        auxCU.setEstadodeDesarrollo(estadodeDesarrollo);
        auxCU.setEstabilidad(estabilidad);
        auxCU.setEsAbstracto(esAbstracto);
        auxCU.setEventoActivacion(eventoActivacion);
        auxCU.setFrecuencia(frecuencia);
        auxCU.setUnidadFrecuencia(unidadFrecuencia);
        auxCU.setPrecondicion(precondicion);
        auxCU.setPostcondicion(postcondicion);

        //// Enlazo el CasodeUso a la lista de CU que tiene el documento
        this.getCaso_de_uso().add(auxCU);
        setChanged();
        notifyObservers();
        return auxCU;
    }

    public Elemento_trazable buscarporNombreCU (String nombre){
        int i=0;
        boolean enc=false;
        while(!enc && i<this.getCaso_de_uso().size()){
            if(this.getCaso_de_uso().get(i).getNombre().equals(nombre)){
                enc=true;
            }
            else{i++;}
        }
        if(enc) return this.getCaso_de_uso().get(i);
        else return null;
       
    }
    public Elemento_trazable buscarporNombreRI (String nombre){
        int i=0;
        boolean enc=false;
        while(!enc && i<this.getMRequisito_Informacion().size()){
            if(this.getMRequisito_Informacion().get(i).getNombre().equals(nombre)){
                enc=true;
            }
            else{i++;}
        }
        if(enc) return this.getMRequisito_Informacion().get(i);
        else return null;

    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.80173724-3F8F-EF4A-D99E-15817CA65636]
    // </editor-fold> 
    public ArrayList<Elemento_trazable> getCaso_de_uso () {
        return mCaso_de_uso;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.DD623546-2AFE-4D5B-5D3A-03A0B28B6761]
    // </editor-fold> 
    public void setCaso_de_uso (ArrayList<Elemento_trazable> val) {
        this.mCaso_de_uso = val;
    }

    /**
     * @return the mRequisito_funcional
     */
    public ArrayList<Elemento_trazable> getMRequisito_funcional() {
        return mRequisito_funcional;
    }

    /**
     * @param mRequisito_funcional the mRequisito_funcional to set
     */
    public void setMRequisito_funcional(ArrayList<Elemento_trazable> mRequisito_funcional) {
        this.mRequisito_funcional = mRequisito_funcional;
    }

    public Req_funcional crearReqFuncional(String nombre, String comentario,ArrayList<Participante> autor,ArrayList<Participante> fuente, String descripcion, String importancia, String urgencia, String est_desarrollo, String estabilidad){
        Req_funcional rF= new Req_funcional();

        rF.setNombre(nombre);
        rF.setComentario(comentario);
        rF.setMAutor(autor);
        rF.setMFuente(fuente);
//        rF.setParticipante(participante);
//        rF.setFuente(fuente);
        rF.setDescripcion(descripcion);
        rF.setImportancia(importancia);
        rF.setUrgencia(urgencia);
        rF.setEstadodeDesarrollo(est_desarrollo);
        rF.setEstabilidad(estabilidad);

        this.getMRequisito_funcional().add(rF);
        setChanged();
        notifyObservers();

        return rF;
    }

    /**
     * @return the mRequisito_Informacion
     */
    public ArrayList<Elemento_trazable> getMRequisito_Informacion() {
        return mRequisito_Informacion;
    }

    /**
     * @param mRequisito_Informacion the mRequisito_Informacion to set
     */
    public void setMRequisito_Informacion(ArrayList<Elemento_trazable> mRequisito_Informacion) {
        this.mRequisito_Informacion = mRequisito_Informacion;
    }

    public Req_informacion crearReqInformacion(String nombre, String comentario,ArrayList<Participante> autor,ArrayList<Participante> fuente, String descripcion, int tMaxValor, String tMaxUnidad, int tMedValor, String tMedUnidad, int nMax, int nMed, String importancia, String urgencia, String est_desarrollo, String estabilidad){
        Req_informacion rI= new Req_informacion();

        rI.setNombre(nombre);
        rI.setComentario(comentario);
        rI.setMAutor(autor);
        rI.setMFuente(fuente);
        rI.setTiempMaxVida_Valor(tMaxValor);
        rI.setTiempoMaxVida_Unidad(tMaxUnidad);
        rI.setTiempoMedVida_Valor(tMedValor);
        rI.setTiempoMedVida_Unidad(tMedUnidad);
        rI.setNMax(nMax);
        rI.setNMed(nMed);
        rI.setDescripcion(descripcion);
        rI.setImportancia(importancia);
        rI.setUrgencia(urgencia);
        rI.setEstadodeDesarrollo(est_desarrollo);
        rI.setEstabilidad(estabilidad);

        this.mRequisito_Informacion.add(rI);
        setChanged();
        notifyObservers();
        return rI;
    }

    /**
     * @return the mRequisito_noFuncioanl
     */
    public ArrayList<Elemento_trazable> getMRequisito_noFuncional() {
        return mRequisito_noFuncional;
    }

    /**
     * @param mRequisito_noFuncioanl the mRequisito_noFuncional to set
     */
    public void setMRequisito_noFuncional(ArrayList<Elemento_trazable> mRequisito_noFuncional) {
        this.mRequisito_noFuncional = mRequisito_noFuncional;
    }

    public Requisito_no_funcional crearRequisito_noFuncional(String nombre, String comentario,ArrayList<Participante> autor,ArrayList<Participante> fuente, String descripcion,String importancia, String urgencia, String est_desarrollo, String estabilidad){
        Requisito_no_funcional rnF= new Requisito_no_funcional();

        rnF.setNombre(nombre);
        rnF.setComentario(comentario);
        rnF.setMAutor(autor);
        rnF.setMFuente(fuente);
        rnF.setDescripcion(descripcion);
        rnF.setImportancia(importancia);
        rnF.setUrgencia(urgencia);
        rnF.setEstadodeDesarrollo(est_desarrollo);
        rnF.setEstabilidad(estabilidad);

        this.getMRequisito_funcional().add(rnF);
        setChanged();
        notifyObservers();
        
        return rnF;
    }

    public ArrayList<Elemento_trazable> getMObjetivo() {
        return mObjetivo;
    }

    public void setMObjetivo(ArrayList<Elemento_trazable> mObjetivo) {
        this.mObjetivo = mObjetivo;

    }

    public Objetivo crearObjetivo(String nombre, String comentario,ArrayList<Participante> autor,ArrayList<Participante> fuente, String descripcion,String importancia, String urgencia, String est_desarrollo, String estabilidad){
        Objetivo ob= new Objetivo();

        ob.setNombre(nombre);
        ob.setComentario(comentario);
        ob.setMAutor(autor);
        ob.setMFuente(fuente);
        ob.setDescripcion(descripcion);
        ob.setImportancia(importancia);
        ob.setUrgencia(urgencia);
        ob.setEstadodeDesarrollo(est_desarrollo);
        ob.setEstabilidad(estabilidad);

        this.getMObjetivo().add(ob);
        setChanged();
        notifyObservers();

        return ob;
    }

    /**
     * @return the mParticipante
     */
    public ArrayList<Elemento_no_trazable> getMParticipante() {
        return mParticipante;
    }

    /**
     * @param mParticipante the mParticipante to set
     */
    public void setMParticipante(ArrayList<Elemento_no_trazable> mParticipante) {
        this.mParticipante = mParticipante;
    }

    public Participante crearParticipante(String nombre, String comentario,ArrayList<Participante> autor,ArrayList<Participante> fuente,String rol, boolean esCliente, boolean esDesarrollador, boolean esUsuario, String org){
        Participante p=new Participante();

        p.setNombre(nombre);
        p.setComentario(comentario);
        p.setMAutor(autor);
        p.setMFuente(fuente);
        p.setRol(rol);
        p.setEsCliente(esCliente);
        p.setEsDesarrollador(esDesarrollador);
        p.setEsUsuario(esUsuario);
        p.setOrganizacion(org);

        this.getMParticipante().add(p);
        setChanged();
        notifyObservers();
        
        return p;


    }
    public Organizacion crearOrganizacion(String nombre, String comentario,ArrayList<Participante> autor,ArrayList<Participante> fuente,String dir, String tlf, String fax){
        Organizacion o=new Organizacion();
        
        o.setNombre(nombre);
        o.setComentario(comentario);
        o.setMAutor(autor);
        o.setMFuente(fuente);
        o.setDireccion(dir);
        o.setTelefono(tlf);
        o.setFax(fax);
        
        this.getMOrganizacion().add(o);
        setChanged();
        notifyObservers();
        
        return o;

    }

    /**
     * @return the mOrganizacion
     */
    public ArrayList<Elemento_no_trazable> getMOrganizacion() {
        return mOrganizacion;
    }

    /**
     * @param mOrganizacion the mOrganizacion to set
     */
    public void setMOrganizacion(ArrayList<Elemento_no_trazable> mOrganizacion) {
        this.mOrganizacion = mOrganizacion;
    }

    /**
     * @return the mReunion
     */
    public ArrayList<Elemento_no_trazable> getMReunion() {
        return mReunion;
    }

    /**
     * @param mReunion the mReunion to set
     */
    public void setMReunion(ArrayList<Elemento_no_trazable> mReunion) {
        this.mReunion = mReunion;
    }

    public Reunion crearReunion(String nombre, String comentario,ArrayList<Participante> autor,ArrayList<Participante> fuente,String lugar, String fecha, String resultados,ArrayList<Participante> asist){
        Reunion r=new Reunion();

        r.setNombre(nombre);
        r.setComentario(comentario);
        r.setMAutor(autor);
        r.setMFuente(fuente);
        r.setLugar(lugar);
        r.setFecha(fecha);
        r.setResultados(resultados);
        r.setMAsistentes(asist);
        this.getMReunion().add(r);
        setChanged();
        notifyObservers();

        return r;
    }

    public void toXML(Object o,Result result,Document document,Element raiz){
        

            if(o instanceof Req_funcional){
                 Req_funcional rf=(Req_funcional) o;
                 Element a= document.createElement("RequisitoFuncional");
                 Element e1=document.createElement("nombre");
                 Text t1= document.createTextNode(rf.getNombre());
                 Element e2=document.createElement("autores");
//                 Element e3=document.createElement("dependencias");
//                 Text t3= document.createTextNode(rf.???);
                 Element e10=document.createElement("fuentes");
                 Element e4=document.createElement("descripcion");
                 Text t4= document.createTextNode("El sistema deberá "+rf.getDescripcion());
                 Element e5=document.createElement("importancia");
                 Text t5= document.createTextNode(rf.getImportancia());
                 Element e6=document.createElement("urgencia");
                 Text t6= document.createTextNode(rf.getUrgencia());
                 Element e7=document.createElement("estado");
                 Text t7= document.createTextNode(rf.getEstadodeDesarrollo());
                 Element e8=document.createElement("estabilidad");
                 Text t8= document.createTextNode(rf.getEstabilidad());
                 Element e9=document.createElement("comentarios");
                 Text t9= document.createTextNode(rf.getComentario());

                 e1.appendChild(t1);
                 for(int i=0; i<rf.getMAutor().size();i++){
                     Text t2= document.createTextNode(rf.getMAutor().get(i).getNombre());
                     e2.appendChild(t2);
                 }
//                 e3.appendChild(t3);
                 e4.appendChild(t4);
                 e5.appendChild(t5);
                 e6.appendChild(t6);
                 e7.appendChild(t7);
                 e8.appendChild(t8);
                 e9.appendChild(t9);
                for(int i=0; i<rf.getMFuente().size();i++){
                     Text t10= document.createTextNode(rf.getMFuente().get(i).getNombre());
                     e10.appendChild(t10);
                 }

                 a.appendChild(e1);
                 a.appendChild(e2);
//                 a.appendChild(e3);
                 a.appendChild(e4);
                 a.appendChild(e5);
                 a.appendChild(e6);
                 a.appendChild(e7);
                 a.appendChild(e8);
                 a.appendChild(e9);
                 a.appendChild(e10);
                 raiz.appendChild(a);

            }

            //hay que mirar y añadir "Dato Especifico" y demás
            else if(o instanceof Req_informacion){
                 Req_informacion rfi=(Req_informacion) o;
                 Element b= document.createElement("RequisitoInformacion");
                 Element ee1=document.createElement("nombre");
                 Text tt1= document.createTextNode(rfi.getNombre());
                 Element ee2=document.createElement("autores");
//                 Element ee3=document.createElement("dependencias");
//                 Text tt3= document.createTextNode(rf.???);
                 Element e10=document.createElement("fuentes");
                 Element ee4=document.createElement("descripcion");
                 Text tt4= document.createTextNode(rfi.getDescripcion());
                 Element ee5=document.createElement("importancia");
                 Text tt5= document.createTextNode(rfi.getImportancia());
                 Element ee6=document.createElement("urgencia");
                 Text tt6= document.createTextNode(rfi.getUrgencia());
                 Element ee7=document.createElement("estado");
                 Text tt7= document.createTextNode(rfi.getEstadodeDesarrollo());
                 Element ee8=document.createElement("estabilidad");
                 Text tt8= document.createTextNode(rfi.getEstabilidad());
                 Element ee9=document.createElement("comentarios");
                 Text tt9= document.createTextNode(rfi.getComentario());
                 Element ee10=document.createElement("tmaximo");
                 Text tt10= document.createTextNode(String.valueOf(rfi.getTiempMaxVida_Valor())+" "+rfi.getTiempoMaxVida_Unidad());
                 Element ee11=document.createElement("tmedio");
                 Text tt11= document.createTextNode(String.valueOf(rfi.getTiempoMedVida_Valor())+" "+rfi.getTiempoMedVida_Unidad());
                 Element ee12=document.createElement("medio");
                 Text tt12= document.createTextNode(String.valueOf(rfi.getNMed()));
                 Element ee13=document.createElement("maximo");
                 Text tt13= document.createTextNode(String.valueOf(rfi.getNMax()));
                 Element ee14=document.createElement("datosEspecificos");

                 ee1.appendChild(tt1);
                  for(int i=0; i<rfi.getMAutor().size();i++){
                     Text tt2= document.createTextNode(rfi.getMAutor().get(i).getNombre());
                     ee2.appendChild(tt2);
                      
                 }
//                 ee3.appendChild(tt3);
                 ee4.appendChild(tt4);
                 ee5.appendChild(tt5);
                 ee6.appendChild(tt6);
                 ee7.appendChild(tt7);
                 ee8.appendChild(tt8);
                 ee9.appendChild(tt9);
                 for(int i=0; i<rfi.getMFuente().size();i++){
                 Text t10= document.createTextNode(rfi.getMFuente().toString());
                 e10.appendChild(t10);
                 }
                 ee10.appendChild(tt10);
                 ee11.appendChild(tt11);
                 ee12.appendChild(tt12);
                 ee13.appendChild(tt13);
                 for(int i=0; i<rfi.getDato_Especifico().size();i++){
                 Text t14= document.createTextNode(rfi.getDato_Especifico().get(i).getDescripcion());
                 ee14.appendChild(t14);
                 }

                 b.appendChild(ee1);
                 b.appendChild(ee2);
//                 b.appendChild(ee3);
                 b.appendChild(ee4);
                 b.appendChild(ee5);
                 b.appendChild(ee6);
                 b.appendChild(ee7);
                 b.appendChild(ee8);
                 b.appendChild(ee9);
                 b.appendChild(e10);
                 b.appendChild(ee10);
                 b.appendChild(ee11);
                 b.appendChild(ee12);
                 b.appendChild(ee13);
                 b.appendChild(ee14);
                 raiz.appendChild(b);

            }

            //hay que mirar y añadir "Excepcion", "Paso", Abstracto y demás
            else if(o instanceof Caso_de_uso){
                Caso_de_uso cdu=(Caso_de_uso) o;
                 Element c= document.createElement("CasoDeUso");
                 Element e1=document.createElement("nombre");
                 Text t1= document.createTextNode(cdu.getNombre());
                 Element e2=document.createElement("autores");
//                 Element e3=document.createElement("dependencias");
//                 Text t3= document.createTextNode(rf.???);
                 Element e10=document.createElement("fuentes");
                 Element e4=document.createElement("descripcion");
                 Text t4;
                 if(cdu.getEsAbstracto()){t4= document.createTextNode("El sistema deberá comportarse tal como se describe en el siguiente caso de uso abstracto durante la realización de los siguientes casos de uso");}
                 else { t4= document.createTextNode("El sistema deberá comportarse tal como se describe en el siguiente caso de uso cuando "+cdu.getEventoActivacion());}
                 Element e5=document.createElement("importancia");
                 Text t5= document.createTextNode(cdu.getImportancia());
                 Element e6=document.createElement("urgencia");
                 Text t6= document.createTextNode(cdu.getUrgencia());
                 Element e7=document.createElement("estado");
                 Text t7= document.createTextNode(cdu.getEstadodeDesarrollo());
                 Element e8=document.createElement("estabilidad");
                 Text t8= document.createTextNode(cdu.getEstabilidad());
                 Element e9=document.createElement("comentarios");
                 Text t9= document.createTextNode(cdu.getComentario());
                 Element e11=document.createElement("precondicion");
                 Text t11= document.createTextNode(cdu.getPrecondicion());
                 Element e12=document.createElement("postcondicion");
                 Text t12= document.createTextNode(cdu.getPostcondicion());
                 Element e13= document.createElement("paso");
                 Element e14=document.createElement("excepciones");
                 Element e15=document.createElement("Rmaximo");

                 e1.appendChild(t1);
                 for(int i=0; i<cdu.getMAutor().size();i++){
                     Text t2= document.createTextNode(cdu.getMAutor().get(i).getNombre());
                     e2.appendChild(t2);
                 }
//                 e3.appendChild(t3);
                 e4.appendChild(t4);
                 e5.appendChild(t5);
                 e6.appendChild(t6);
                 e7.appendChild(t7);
                 e8.appendChild(t8);
                 e9.appendChild(t9);
                for(int i=0; i<cdu.getMFuente().size();i++){
                     Text t10= document.createTextNode(cdu.getMFuente().get(i).getNombre());
                     e10.appendChild(t10);
                 }
                 e11.appendChild(t11);
                 e12.appendChild(t12);
                 for(int i=0; i<cdu.getPaso().size();i++){
                     Text t13= document.createTextNode(cdu.getPaso().get(i).getDescripcion());
                     e13.appendChild(t13);
                     Text t15 =document.createTextNode(cdu.getPaso().get(i).getValorRendimiento()+" "+cdu.getPaso().get(i).getUnidadRendimiento());
                     e15.appendChild(t15);
                     for(int j=0; j<cdu.getPaso().get(i).getExcepcion().size();j++){
                         Text t14= document.createTextNode(cdu.getPaso().get(i).getExcepcion().get(j).getDescripcion());
                     e14.appendChild(t14);
                     }
                 }

                 c.appendChild(e1);
                 c.appendChild(e2);
//                 c.appendChild(e3);
                 c.appendChild(e4);
                 c.appendChild(e5);
                 c.appendChild(e6);
                 c.appendChild(e7);
                 c.appendChild(e8);
                 c.appendChild(e9);
                 c.appendChild(e10);
                 c.appendChild(e11);
                 c.appendChild(e12);
                 c.appendChild(e13);
                 c.appendChild(e14);
                 c.appendChild(e15);
                 raiz.appendChild(c);
            }
            else if(o instanceof Requisito_no_funcional){
            Requisito_no_funcional rnf=(Requisito_no_funcional) o;
                 Element d= document.createElement("RequisitoNoFuncional");
                 Element e1=document.createElement("nombre");
                 Text t1= document.createTextNode(rnf.getNombre());
                 Element e2=document.createElement("autores");
//                 Element e3=document.createElement("dependencias");
//                 Text t3= document.createTextNode(rf.???);
                 Element e10=document.createElement("fuentes");
                 Element e4=document.createElement("descripcion");
                 Text t4= document.createTextNode("El sistema deberá "+rnf.getDescripcion());
                 Element e5=document.createElement("importancia");
                 Text t5= document.createTextNode(rnf.getImportancia());
                 Element e6=document.createElement("urgencia");
                 Text t6= document.createTextNode(rnf.getUrgencia());
                 Element e7=document.createElement("estado");
                 Text t7= document.createTextNode(rnf.getEstadodeDesarrollo());
                 Element e8=document.createElement("estabilidad");
                 Text t8= document.createTextNode(rnf.getEstabilidad());
                 Element e9=document.createElement("comentarios");
                 Text t9= document.createTextNode(rnf.getComentario());

                 e1.appendChild(t1);
                 for(int i=0; i<rnf.getMAutor().size();i++){
                     Text t2= document.createTextNode(rnf.getMAutor().get(i).getNombre());
                     e2.appendChild(t2);
                 }
//                 e3.appendChild(t3);
                 e4.appendChild(t4);
                 e5.appendChild(t5);
                 e6.appendChild(t6);
                 e7.appendChild(t7);
                 e8.appendChild(t8);
                 e9.appendChild(t9);
                for(int i=0; i<rnf.getMFuente().size();i++){
                     Text t10= document.createTextNode(rnf.getMFuente().get(i).getNombre());
                     e10.appendChild(t10);
                 }

                 d.appendChild(e1);
                 d.appendChild(e2);
//                 d.appendChild(e3);
                 d.appendChild(e4);
                 d.appendChild(e5);
                 d.appendChild(e6);
                 d.appendChild(e7);
                 d.appendChild(e8);
                 d.appendChild(e9);
                 d.appendChild(e10);
                 raiz.appendChild(d);
            }

            else if(o instanceof Objetivo){
            Objetivo ob=(Objetivo) o;
                 Element e= document.createElement("Objetivo");
                 Element e1=document.createElement("nombre");
                 Text t1= document.createTextNode(ob.getNombre());
                 Element e2=document.createElement("autores");
//                 Element e3=document.createElement("dependencias");
//                 Text t3= document.createTextNode(rf.???);
                 Element e10=document.createElement("fuentes");
                 Element e4=document.createElement("descripcion");
                 Text t4= document.createTextNode("El sistema deberá "+ob.getDescripcion());
                 Element e5=document.createElement("importancia");
                 Text t5= document.createTextNode(ob.getImportancia());
                 Element e6=document.createElement("urgencia");
                 Text t6= document.createTextNode(ob.getUrgencia());
                 Element e7=document.createElement("estado");
                 Text t7= document.createTextNode(ob.getEstadodeDesarrollo());
                 Element e8=document.createElement("estabilidad");
                 Text t8= document.createTextNode(ob.getEstabilidad());
                 Element e9=document.createElement("comentarios");
                 Text t9= document.createTextNode(ob.getComentario());

                 e1.appendChild(t1);
                 for(int i=0; i<ob.getMAutor().size();i++){
                     Text t2= document.createTextNode(ob.getMAutor().get(i).getNombre());
                     e2.appendChild(t2);
                 }
//                 e3.appendChild(t3);
                 e4.appendChild(t4);
                 e5.appendChild(t5);
                 e6.appendChild(t6);
                 e7.appendChild(t7);
                 e8.appendChild(t8);
                 e9.appendChild(t9);
                for(int i=0; i<ob.getMFuente().size();i++){
                     Text t10= document.createTextNode(ob.getMFuente().get(i).getNombre());
                     e10.appendChild(t10);
                 }

                 e.appendChild(e1);
                 e.appendChild(e2);
//                 e.appendChild(e3);
                 e.appendChild(e4);
                 e.appendChild(e5);
                 e.appendChild(e6);
                 e.appendChild(e7);
                 e.appendChild(e8);
                 e.appendChild(e9);
                 e.appendChild(e10);
                 raiz.appendChild(e);
            }
            //Mirar Participante la parte de añadir una Organizacion
            else if(o instanceof Participante){
            Participante par=(Participante) o;
                 Element f1= document.createElement("Participante");
                 Element e1=document.createElement("nombre");
                 Text t1= document.createTextNode(par.getNombre());
                 Element e2=document.createElement("autores");
                 Element e10=document.createElement("fuentes");
                 Element e3=document.createElement("rol");
                 Text t3= document.createTextNode(par.getRol());
                 Element e4=document.createElement("cliente");
                 Text t4,t5,t6;

                 if (par.getEsCliente()){
                 t4= document.createTextNode("Sí.");
                 }
                 else t4= document.createTextNode("No.");
                 Element e5=document.createElement("desarrollador");
                 if(par.getEsDesarrollador()){
                 t5= document.createTextNode("Sí.");
                 }
                 else t5= document.createTextNode("No.");
                 Element e6=document.createElement("usuario");
                 if(par.getEsUsuario()){
                 t6= document.createTextNode("Sí.");
                 }
                 else t6=document.createTextNode("No.");

                 Element e7=document.createElement("comentarios");
                 Text t7= document.createTextNode(par.getComentario());
                 Element e8=document.createElement("Porganizacion");
                 Text t8= document.createTextNode(par.getOrganizacion());



                
                 e1.appendChild(t1);
                 for(int i=0; i<par.getMAutor().size();i++){
                     Text t2= document.createTextNode(par.getMAutor().get(i).getNombre());
                     e2.appendChild(t2);
                 }
                 for(int i=0; i<par.getMFuente().size();i++){
                     Text t10= document.createTextNode(par.getMFuente().get(i).getNombre());
                     e10.appendChild(t10);
                 }
                 e3.appendChild(t3);
                 e4.appendChild(t4);
                 e5.appendChild(t5);
                 e6.appendChild(t6);
                 e7.appendChild(t7);
                 e8.appendChild(t8);
                 f1.appendChild(e1);
                 f1.appendChild(e2);
                 f1.appendChild(e3);
                 f1.appendChild(e4);
                 f1.appendChild(e5);
                 f1.appendChild(e6);
                 f1.appendChild(e7);
                 f1.appendChild(e8);
                 f1.appendChild(e10);
                 raiz.appendChild(f1);
            }
            
            else if(o instanceof Organizacion){
            Organizacion or=(Organizacion) o;
                 Element g= document.createElement("Organizacion");
                 Element e1=document.createElement("nombre");
                 Text t1= document.createTextNode(or.getNombre());
                 Element e2=document.createElement("autores");
                 Element e10=document.createElement("fuentes");
                 Element e3=document.createElement("direccion");
                 Text t3= document.createTextNode(or.getDireccion());
                 Element e4=document.createElement("telefono");
                 Text t4= document.createTextNode(or.getTelefono());
                 Element e5=document.createElement("fax");
                 Text t5= document.createTextNode(or.getFax());
                 Element e6=document.createElement("participantes");
                 Element e7=document.createElement("comentarios");
                 Text t7= document.createTextNode(or.getComentario());

                 e1.appendChild(t1);
                 for(int i=0; i<or.getMAutor().size();i++){
                     Text t2= document.createTextNode(or.getMAutor().get(i).getNombre());
                     e2.appendChild(t2);
                 }
                 for(int i=0; i<or.getMFuente().size();i++){
                     Text t10= document.createTextNode(or.getMFuente().get(i).getNombre());
                     e10.appendChild(t10);
                 }
                 e3.appendChild(t3);
                 e4.appendChild(t4);
                 e5.appendChild(t5);
                 for(int i=0; i<or.getPart_Asociados().size();i++){
                     Text t6= document.createTextNode(or.getPart_Asociados().get(i).getNombre());
                     e6.appendChild(t6);
                 }
                 e7.appendChild(t7);
                 g.appendChild(e1);
                 g.appendChild(e2);
                 g.appendChild(e3);
                 g.appendChild(e4);
                 g.appendChild(e5);
                 g.appendChild(e6);
                 g.appendChild(e7);
                 g.appendChild(e10);

                 raiz.appendChild(g);
            }

            else if(o instanceof Reunion){
            Reunion re=(Reunion) o;
                 Element h= document.createElement("Reunion");
                 Element e1=document.createElement("nombre");
                 Text t1= document.createTextNode(re.getNombre());
                 Element e2=document.createElement("autores");
                 Element e10=document.createElement("fuentes");
                 Element e3=document.createElement("lugar");
                 Text t3= document.createTextNode(re.getLugar());
                 Element e4=document.createElement("fecha");
                 Text t4= document.createTextNode(re.getFecha());
                 Element e5=document.createElement("resultados");
                 Text t5= document.createTextNode(re.getResultados());
                 Element e6=document.createElement("asistentes");
                 Element e7=document.createElement("comentarios");
                 Text t7= document.createTextNode(re.getComentario());

                 e1.appendChild(t1);
                 for(int i=0; i<re.getMAutor().size();i++){
                     Text t2= document.createTextNode(re.getMAutor().get(i).getNombre());
                     e2.appendChild(t2);
                 }
                 for(int i=0; i<re.getMFuente().size();i++){
                     Text t10= document.createTextNode(re.getMFuente().get(i).getNombre());
                     e10.appendChild(t10);
                 }
                 e3.appendChild(t3);
                 e4.appendChild(t4);
                 e5.appendChild(t5);
                 for(int i=0; i<re.getMAsistentes().size();i++){
                     Text t6= document.createTextNode(re.getMAsistentes().get(i).getNombre());
                     e6.appendChild(t6);
                 }
                 e7.appendChild(t7);
                 h.appendChild(e1);
                 h.appendChild(e2);
                 h.appendChild(e3);
                 h.appendChild(e4);
                 h.appendChild(e5);
                 h.appendChild(e6);
                 h.appendChild(e7);
                 h.appendChild(e10);
                 raiz.appendChild(h);
            }


            Source source = new DOMSource(document);
            
            
            Result console= new StreamResult(System.out);
            try{
            Transformer transformer = TransformerFactory.newInstance().newTransformer();
            transformer.transform(source, result);
            transformer.transform(source, console);
            }
            catch(Exception e){System.out.println(e);}
        
    }
    
}

